#!/bin/tclsh
# dont miss to modify that if is needed..
###########################################
#      Mr V FreeSpace Maker v1.0          #
###########################################
#           PUBLIC RELEASE                #
###########################################
# Features:                               #
# -Arhives/Deletes old releases           #
# -glfTPD Log compatible                  #
# -Easy Configuration                     #
# -Multiple dirs per disk                 #
# -Multiple disks per site                #
# -All-in-one based script                #
# -Valid on dated dirs (dels a whole day) #
# -Valid on folder-releases dirs          #
# -Excluded tags                          #
# -Special tags                           #
# -SQL Log feature                        #
#                                         #
#                                         #
# Crontab "5,*5,*0,00 * * * *"            #
# Configure it correctly..                #
#                                         #
# Needs:                                  #
# Binarys on /glftpd/bin: du df           #
# Tcl 8.4 atleast                         #
# Tcl-Sql                                 #
# SQL (Mysql,Postgres,Oracle..)           #
#                                         #
# SQL Table:                              #
# create table vFree (                    #
#   releaseName VARCHAR(255) NOT NULL,    #
#   dateMake VARCHAR(50) NOT NULL,        #
#   dateDel VARCHAR(50) NOT NULL,         #
#   dateSecs VARCHAR(100) NOT NULL,       #
#   section VARCHAR(50) NOT NULL,         #
#   size VARCHAR(50) NOT NULL,            #
#   PRIMARY KEY (dateDel, releaseName)    #
# );                                      #
#                                         #
# The glftpd Log Output Structure is:     #
# RELEASENAME SECTION SIZE                #
# You must edit your sitebot TCL that read#
# the gllog and customize the output..    #
#                                         #
###########################################
# Author: Mr_V  <vampirito@vampirito.com> #
###########################################
# Extra Notes:                            #
# Hi! if you got any idea about a script  #
# that can be good to develope.. or ..    #
# anything like that send me the idea and #
# i will try to code it and make it public#
#                      Best Regards, Mr_V #
###########################################
# glfTPD Based log
set log(glftpd)		"1"
# glfTPD log location
set log(gllog)		"/glftpd/ftp-data/logs/glftpd.log"
# Excluded
# A folder that is on a CheckZone and wants to be Skipped
set free(excluded) 	"*Mvids* Archive-Mp3"
# Units configuration
# Take carefull of that
# Trick: if you want to wipe XMbs from every section that is
# in the same disk.. put another FREEMBS.. doing a small jump..
# NAME:DEVICE:LOCATION:FREEMBS:ARCHIVE DIRECTORY
# If ARCHIVE Directory is not specifed the Archive routine will be
# skipped and the directory deleted.
set sections {
DiVX:/dev/hda1:/glftpd/site/ViDEO/DiVX:1500:
Mp3:/dev/hda1:/glftpd/site/Mp3:3000:/glftpd/site/Archive/Mp3
0-Day:/dev/hda1:/glftpd/site/0-Day:1500:/glftpd/site/Archive/0-Day
iSO-GaMES:/dev/hda1:/glftpd/site/iSO/GaMES:1500:
}
# This is the part for 'store stuff' else if is full or not
# such as keygen.. releases from a group (nice for WHQ) (glob type)
# STRING:DESTINATION
set special {
*Keygen*:/glftpd/site/Archive/KeyGenz
*-MTC:/glftpd/site/Archive/MTC
}

# where's the MySQL-Tcl API?
load /usr/lib/sql.so
# SQL Configuration 0/1 disable/enable
set sql(status)		"1"
set sql(host)		"127.0.0.1"
set sql(login)		"vScript"
set sql(pass)		"vscr1pt0r3d"
set sql(db)		"vScripts"
set sql(table)		"vFree"

proc vfr:checkUnits {} {global log free sql special
	set sections [vfr:getSName]
	foreach section $sections {
		puts "  vFREE: Checking $section section.. please be patient.."
		set device($section) "[vfr:getSDevice $section]"
		set dir($section) "[vfr:getSDirectory $section]"
		set free($section) "[vfr:getSFree $section]"
		set dest($section) "[vfr:getSDestination $section]"
		set ufree($section) "[vfr:getUFree $device($section)]"
		if {"$ufree($section)" == "N/A"} {
			puts "  vFREE: UnitDevice of $section section ($device($section)) not found or not mounted"
			set mount($section)	"0"
		} else {
			set mount($section)	"1"
		}
		if {$mount($section) == "1"} {
			if {$ufree($section) < $free($section)} {
				set clean($section)	"1"
				set dirs($section)	"[glob -nocomplain -path $dir($section)/ * -types d]"
				foreach temp $dirs($section) {
					if {![info exist releases($section)]} {
						set releases($section) "\{$temp [file mtime $temp]\}"
					} else {
						lappend releases($section) "$temp [file mtime $temp]"
					}
				}
				set releases($section) "[lsort -increasing -integer -index 1 $releases($section)]"
				set num 0
				while {$ufree($section) < $free($section)} {
					if {"[lindex [lindex $releases($section) $num] 1]" == ""} {
						puts "  vFREE: Deleted all but still needing space.."
						break
					}
					set relDate "[clock format [lindex [lindex $releases($section) $num] 1] -format "%H:%M:%S %d-%m-%Y"]"
					set relName [lindex [lindex $releases($section) $num] 0]
					set currDate "[clock format [clock seconds] -format "%H:%M:%S %d-%m-%Y"]"
					set currDateb "[lindex [lindex $releases($section) $num] 1] [clock seconds]"
					set relSize [vfr:getSize $relName]
					set speecz [lindex [vfr:checkSpecial $relName] 0]
					if {$speecz != 0} {
						set specialDir 1
						set specialDest [lindex [vfr:checkSpecial $relName] 1]
					} else {
						set specialDir 0
					}
					foreach excFr $free(excluded) {
						if {[string match "[string tolower $excFr]" [string tolower $relName]]} {
							set skipDir 1
						}
					}
					if {![info exist skipDir]} {
						set skipDir 0
					}
					if {$skipDir == 1} {
						puts "  vFREE: ($section) Skipped directory [name $relName] coz is excempted.."
					} elseif {$specialDir == 1} {
						puts "  vFREE: ($section) Special directory found [name $relName] moving to specialDestination"
						vfr:moveRelease $relName $specialDest
					} elseif {$dest($section) == "DEL"} {
						puts "  vFREE: ($section) Wipped [name $relName] ($relSize KBs)"
						file delete -force $relName
					} elseif {[lindex $dest($section) 0] == "ARCHIVE"} {
						puts "  vFREE: ($section) Archived [name $relName] ($relSize KBs)"
						if {($skipDir == 0) && ($specialDir == 0) && ($log(glftpd) == 1)} {
							set skipDir 1
							if {![file writable $log(gllog)]} {
								puts "  vFREE: glfTPD Log routine skipped coz log is not writable"
							} else {
								set log_format "[clock format [clock seconds] -format "%a %b %d %T %Y"]"
								set of [open $log(gllog) a]
								puts $of "$log_format ARCHIVED: \"[name $relName]\" \"$section\" \"$relSize\""
								close $of
							}
						}						
						vfr:moveRelease "$relName" "[lindex $dest($section) 1]"
					} else {
						puts "  vFREE: Action not configured (SKIPPING DEL/ARCHIVE ROUTINE)"
					}
					if {($skipDir == 0) && ($sql(status) == 1) && ($specialDir == 0)} {
						vfr:addSql "$relName" "$relDate" "$currDate" "$currDateb" "$section" "$relSize"
					} else {
						puts "  vFREE: SQL Routine skipped"
					}
					if {($skipDir == 0) && ($specialDir == 0) && ($log(glftpd) == 1)} {
						if {![file writable $log(gllog)]} {
							puts "  vFREE: glfTPD Log routine skipped coz log is not writable"
						} else {
							set log_format "[clock format [clock seconds] -format "%a %b %d %T %Y"]"
							set of [open $log(gllog) a]
							puts $of "$log_format FREE: \"[name $relName]\" \"$section\" \"$relSize\""
							close $of
						}
					} else {
						puts "  vFREE: glfTPD Log routine skipped"
					}
					incr num
					set ufree($section) "[vfr:getUFree $device($section)]"
					unset skipDir
					unset specialDir
				}			
			} else {
				puts "  vFREE: $section section dont need clean"
				set clean($section)	"0"
			}
		}
	}
}

proc vfr:checkSpecial {release} { global special
	foreach string $special {
		set str [lindex [split $string ":"] 0]
		set dst [lindex [split $string ":"] 1]
		if {[string match "[string tolower $str]" [string tolower $release]]} {
			return "1 $dst"
		}
	}
return 0
}

proc vfr:moveRelease {release dest} { global env siteName
	set release [lindex $release 0]
	set dest [lindex $dest 0]
	if {([file isdirectory $release]) && ([file isdirectory $dest])} {
		exec -- mv -f $release ${dest}/
		if {![file isdirectory $release]} {
			puts "  vFREE: [name $release] Archived correctly in [name $dest]"
		} else {
			puts "  vFREE: Error Moving Release.. (Multiple HDs)"
			puts "  vFREE: Copying Release.. (This will take a while)"
			exec -- /bin/cp -R [pwd]/$release ${dest}/
			puts "  vFREE: Copied Sucessfully"
			puts "  vFREE: [name $release] Archived correctly in [name $dest]"
		}
	}
}

proc name {fpath} {
        set split [split $fpath "/"]
        set ll [llength $split]
        if {$ll < 3} {return "\{ERR\} \{ERR\}"}
        set loc "[lindex $split [expr $ll - 2]]"
        set rel "[lindex $split [expr $ll - 1]]"
        if {[string match "\[cC\]\[dD\]\[0-9\]" $rel] || [string match "\[sS\]\[aA\]\[mM\]\[pP\]\[lL\]\[eE\]*" $rel] || [string match "\[dD\]\[iI\]\[sS\]\[cCkK\]*" $rel] || [string match "\[pP\]\[aA\]\[rR\]\[tT\]*" $rel]} {
                set loc "[lindex $split [expr $ll - 3]]"
                set rel "[lindex $split [expr $ll - 2]]/$rel"
        } 
        return "\{$rel\}"
}

proc vfr:getUFree {unit} {
	set df(exec) [split [exec -- /glftpd/bin/df -k] "\n"]
	foreach df(line) $df(exec) {
		if {[string equal "[string tolower $unit]" "[lindex $df(line) 0]"]} {
			set df(free) "[lindex $df(line) 3]"
		}
	}
	if {![info exist df(free)]} {
		return "N/A"
	} else {
		return "$df(free)"
	}
}

proc vfr:getSName {} { global sections
	foreach section(line) $sections {
		if {![info exist section(name)]} {
			set section(name) "[lindex [split $section(line) ":"] 0]"
		} else {
			append section(name) " [lindex [split $section(line) ":"] 0]"
		}
	}
return $section(name)
}

proc vfr:getSDevice {sname} { global sections
	set section(name) $sname
	foreach section(line) $sections {
		if {[string match "[string tolower $section(name)]*" "[string tolower $section(line)]"]} {
			set section(device) "[lindex [split $section(line) ":"] 1]"
		}
	}
	if {![info exist section(device)]} {
		return 0
	} else {
		return "$section(device)"
	}
}

proc vfr:getSDirectory {sname} { global sections
	set section(name) $sname
	foreach section(line) $sections {
		if {[string match "[string tolower $section(name)]*" "[string tolower $section(line)]"]} {
			set section(dir) "[lindex [split $section(line) ":"] 2]"
		}
	}
	if {![info exist section(dir)]} {
		return 0
	} else {
		return "$section(dir)"
	}
}

proc vfr:getSFree {sname} { global sections
	set section(name) $sname
	foreach section(line) $sections {
		if {[string match "[string tolower $section(name)]*" "[string tolower $section(line)]"]} {
			set section(free) "[expr [lindex [split $section(line) ":"] 3] * 1024]"
		}
	}
	if {![info exist section(free)]} {
		return 0
	} else {
		return "$section(free)"
	}
}

proc vfr:getSDestination {sname} { global sections
	set section(name) $sname
	foreach section(line) $sections {
		if {[string match "[string tolower $section(name)]*" "[string tolower $section(line)]"]} {
			set section(dest) "[lindex [split $section(line) ":"] 4]"
		}
	}
	if {![info exist section(dest)]} {
		return 0
	} elseif {"$section(dest)" == ""} {
		return "DEL"
	} else {
		return "ARCHIVE $section(dest)"
	}
}

proc vfr:getSize {dir} {
	set size "[lindex [exec -- /glftpd/bin/du -s ${dir}] 0]"
	return $size
}

proc db:connect {} { global sql
        set sql(conn) [sql connect $sql(host) $sql(login) $sql(pass)]
        sql selectdb $sql(conn) $sql(db)
}

proc db:disconnect {} { global sql
        catch {sql endquery $sql(conn)}
}

proc db:query {myQuery} { global sql
        sql query $sql(conn) $myQuery
        upvar 1 rows rows
        set rows ""
        while {[set row [sql fetchrow $sql(conn)]] != ""} {
                if {[llength $row] != 1} {
                        lappend rows $row
                } else {
                        lappend rows [lindex $row 0]
                }
        }
        catch {sql endquery $sql(conn)}
        if {([string index $rows 0] == "\{") && ([llength $rows] == 1)} {
                set rows [lindex $rows 0]
        }
        return 0
}

proc vfr:addSql {releaseName dateMake dateDel dateSecs section size} { global sql
	db:connect
	puts "  vFREE: Added to dB [name $releaseName] ($section) entry (SQL)"
	sql exec $sql(conn) "INSERT INTO `$sql(table)` VALUES ('$releaseName', '$dateMake', '$dateDel', '$dateSecs', '$section', '$size');"
}
vfr:checkUnits
